#include <stdio.h>
#include "jpeglib.h"

int main(int argc , char *argv[]) {
  struct jpeg_decompress_struct cinfoForInput;
  struct jpeg_compress_struct cinfoForOutput;
  struct jpeg_error_mgr jerr;
  
  int row_stride;
  JSAMPARRAY buffer;
  FILE *infile, *outfile;

  if(argc != 3) {
    fputs("usage: jpegsample src dst", stdout);
    return 2;
  }
  cinfoForInput.err = jpeg_std_error(&jerr);
  cinfoForOutput.err = jpeg_std_error(&jerr);
  jpeg_create_decompress(&cinfoForInput); 
  if ((infile = fopen(argv[1], "rb")) == NULL) {
    perror(argv[1]);
    return 1;
  }
  jpeg_stdio_src(&cinfoForInput, infile);  
  jpeg_create_compress(&cinfoForOutput);
  if ((outfile = fopen(argv[2], "wb")) == NULL) {
    perror(argv[2]);
    return 1;
  }
  jpeg_stdio_dest(&cinfoForOutput, outfile);
  jpeg_read_header(&cinfoForInput, TRUE);
  jpeg_start_decompress(&cinfoForInput);
  printf("converting width=%d,height=%d,component=%d\n", 
    cinfoForInput.image_width, cinfoForInput.image_height,
    cinfoForInput.output_components);
  cinfoForOutput.image_width = cinfoForInput.image_width;
  cinfoForOutput.image_height = cinfoForInput.image_height;
  cinfoForOutput.in_color_space = JCS_RGB;
  cinfoForOutput.input_components = 
    cinfoForInput.output_components;
  jpeg_set_defaults(&cinfoForOutput);

  cinfoForOutput.scale_num = 1;
  cinfoForOutput.scale_denom = 2;
  jpeg_start_compress(&cinfoForOutput, TRUE);
  row_stride = cinfoForInput.output_width * 
    cinfoForInput.output_components;
  buffer = (*cinfoForInput.mem->alloc_sarray)
    ((j_common_ptr) &cinfoForInput,
    JPOOL_IMAGE, row_stride, 1);
  while (cinfoForInput.output_scanline < 
    cinfoForInput.output_height) {
    jpeg_read_scanlines(&cinfoForInput, buffer, 1);
    jpeg_write_scanlines(&cinfoForOutput, buffer, 1);
  }

  jpeg_finish_compress(&cinfoForOutput);
  fclose(infile);
  fclose(outfile);
  jpeg_destroy_decompress(&cinfoForInput);
  jpeg_destroy_compress(&cinfoForOutput);

  return 0;
}
